
_interrupt:

;FlowBoard Mini.c,81 :: 		void interrupt() {
;FlowBoard Mini.c,82 :: 		if (TMR0IF_bit){    //Servos
	BTFSS       TMR0IF_bit+0, BitPos(TMR0IF_bit+0) 
	GOTO        L_interrupt0
;FlowBoard Mini.c,84 :: 		TMR0IF_bit = 0;
	BCF         TMR0IF_bit+0, BitPos(TMR0IF_bit+0) 
;FlowBoard Mini.c,86 :: 		if (set1 ==1){
	MOVF        _set1+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_interrupt1
;FlowBoard Mini.c,87 :: 		D0 = 1;
	BSF         LATD4_bit+0, BitPos(LATD4_bit+0) 
;FlowBoard Mini.c,88 :: 		set1 = 0;
	CLRF        _set1+0 
;FlowBoard Mini.c,90 :: 		TMR0H = s0H;         // Set Timer0 Interrupt time     should come from readbuff 3 & 4
	MOVF        _s0H+0, 0 
	MOVWF       TMR0H+0 
;FlowBoard Mini.c,91 :: 		TMR0L = s0L;         // Servo Min = 58284 Max = 37125
	MOVF        _s0L+0, 0 
	MOVWF       TMR0L+0 
;FlowBoard Mini.c,93 :: 		}else {
	GOTO        L_interrupt2
L_interrupt1:
;FlowBoard Mini.c,94 :: 		D0 = 0;
	BCF         LATD4_bit+0, BitPos(LATD4_bit+0) 
;FlowBoard Mini.c,95 :: 		}
L_interrupt2:
;FlowBoard Mini.c,96 :: 		if (set2 ==1){
	MOVF        _set2+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_interrupt3
;FlowBoard Mini.c,97 :: 		D1 = 1;
	BSF         LATD5_bit+0, BitPos(LATD5_bit+0) 
;FlowBoard Mini.c,98 :: 		set2 = 0;
	CLRF        _set2+0 
;FlowBoard Mini.c,100 :: 		TMR0H = s1H;         // Set Timer0 Interrupt time     should come from readbuff 3 & 4
	MOVF        _s1H+0, 0 
	MOVWF       TMR0H+0 
;FlowBoard Mini.c,101 :: 		TMR0L = S1L;         // Servo Min = 58284 Max = 37125
	MOVF        _s1L+0, 0 
	MOVWF       TMR0L+0 
;FlowBoard Mini.c,103 :: 		}else {
	GOTO        L_interrupt4
L_interrupt3:
;FlowBoard Mini.c,104 :: 		D1 = 0;
	BCF         LATD5_bit+0, BitPos(LATD5_bit+0) 
;FlowBoard Mini.c,105 :: 		}
L_interrupt4:
;FlowBoard Mini.c,107 :: 		} else {
	GOTO        L_interrupt5
L_interrupt0:
;FlowBoard Mini.c,109 :: 		USB_Interrupt_Proc();                   // USB servicing is done inside the interrupt
	CALL        _USB_Interrupt_Proc+0, 0
;FlowBoard Mini.c,111 :: 		}
L_interrupt5:
;FlowBoard Mini.c,112 :: 		}
L_end_interrupt:
L__interrupt39:
	RETFIE      1
; end of _interrupt

_InitTimer0:

;FlowBoard Mini.c,116 :: 		void InitTimer0(){
;FlowBoard Mini.c,117 :: 		T0CON         = 0x88;
	MOVLW       136
	MOVWF       T0CON+0 
;FlowBoard Mini.c,118 :: 		TMR0H         = 0xBA;     //BA58 = 47704 = 1.5ms
	MOVLW       186
	MOVWF       TMR0H+0 
;FlowBoard Mini.c,119 :: 		TMR0L         = 0x58;
	MOVLW       88
	MOVWF       TMR0L+0 
;FlowBoard Mini.c,120 :: 		GIE_bit       = 1;        //Enable Interrupts
	BSF         GIE_bit+0, BitPos(GIE_bit+0) 
;FlowBoard Mini.c,121 :: 		TMR0IF_bit    = 0;
	BCF         TMR0IF_bit+0, BitPos(TMR0IF_bit+0) 
;FlowBoard Mini.c,122 :: 		TMR0IE_bit    = 1;
	BSF         TMR0IE_bit+0, BitPos(TMR0IE_bit+0) 
;FlowBoard Mini.c,125 :: 		s0H = 0xBA;
	MOVLW       186
	MOVWF       _s0H+0 
;FlowBoard Mini.c,126 :: 		s0L = 0x58;
	MOVLW       88
	MOVWF       _s0L+0 
;FlowBoard Mini.c,127 :: 		s1H = 0xBA;
	MOVLW       186
	MOVWF       _s1H+0 
;FlowBoard Mini.c,128 :: 		s1L = 0x58;
	MOVLW       88
	MOVWF       _s1L+0 
;FlowBoard Mini.c,130 :: 		}
L_end_InitTimer0:
	RETURN      0
; end of _InitTimer0

_clear_USB_buffers:

;FlowBoard Mini.c,132 :: 		void clear_USB_buffers()
;FlowBoard Mini.c,134 :: 		for (i=0; i<63;i++)
	CLRF        _i+0 
L_clear_USB_buffers6:
	MOVLW       63
	SUBWF       _i+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_clear_USB_buffers7
;FlowBoard Mini.c,136 :: 		readbuff[i] = 0;
	MOVLW       _readbuff+0
	MOVWF       FSR1 
	MOVLW       hi_addr(_readbuff+0)
	MOVWF       FSR1H 
	MOVF        _i+0, 0 
	ADDWF       FSR1, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR1H, 1 
	CLRF        POSTINC1+0 
;FlowBoard Mini.c,137 :: 		writebuff[i] = 0;
	MOVLW       _writebuff+0
	MOVWF       FSR1 
	MOVLW       hi_addr(_writebuff+0)
	MOVWF       FSR1H 
	MOVF        _i+0, 0 
	ADDWF       FSR1, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR1H, 1 
	CLRF        POSTINC1+0 
;FlowBoard Mini.c,134 :: 		for (i=0; i<63;i++)
	INCF        _i+0, 1 
;FlowBoard Mini.c,138 :: 		}
	GOTO        L_clear_USB_buffers6
L_clear_USB_buffers7:
;FlowBoard Mini.c,139 :: 		}
L_end_clear_USB_buffers:
	RETURN      0
; end of _clear_USB_buffers

_read_button1:

;FlowBoard Mini.c,141 :: 		char read_button1() {
;FlowBoard Mini.c,142 :: 		if (Button(&PORTD, 3, 2, 0)) {               // Detect logical one
	MOVLW       PORTD+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTD+0)
	MOVWF       FARG_Button_port+1 
	MOVLW       3
	MOVWF       FARG_Button_pin+0 
	MOVLW       2
	MOVWF       FARG_Button_time_ms+0 
	CLRF        FARG_Button_active_state+0 
	CALL        _Button+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_read_button19
;FlowBoard Mini.c,143 :: 		return  1;                              // Update flag
	MOVLW       1
	MOVWF       R0 
	GOTO        L_end_read_button1
;FlowBoard Mini.c,144 :: 		} else return 0;
L_read_button19:
	CLRF        R0 
;FlowBoard Mini.c,145 :: 		}
L_end_read_button1:
	RETURN      0
; end of _read_button1

_read_button2:

;FlowBoard Mini.c,147 :: 		char read_button2() {
;FlowBoard Mini.c,148 :: 		if (Button(&PORTD, 2, 2, 0)) {               // Detect logical one
	MOVLW       PORTD+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTD+0)
	MOVWF       FARG_Button_port+1 
	MOVLW       2
	MOVWF       FARG_Button_pin+0 
	MOVLW       2
	MOVWF       FARG_Button_time_ms+0 
	CLRF        FARG_Button_active_state+0 
	CALL        _Button+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_read_button211
;FlowBoard Mini.c,149 :: 		return  2;                              // Update flag
	MOVLW       2
	MOVWF       R0 
	GOTO        L_end_read_button2
;FlowBoard Mini.c,150 :: 		} else return 0;
L_read_button211:
	CLRF        R0 
;FlowBoard Mini.c,151 :: 		}
L_end_read_button2:
	RETURN      0
; end of _read_button2

_main:

;FlowBoard Mini.c,153 :: 		void main(){
;FlowBoard Mini.c,154 :: 		long cnt = 0;
	CLRF        main_cnt_L0+0 
	CLRF        main_cnt_L0+1 
	CLRF        main_cnt_L0+2 
	CLRF        main_cnt_L0+3 
;FlowBoard Mini.c,156 :: 		ANCON0 = 0;               // Default all pins to digital
	CLRF        ANCON0+0 
;FlowBoard Mini.c,157 :: 		ANCON1 = 0;
	CLRF        ANCON1+0 
;FlowBoard Mini.c,158 :: 		TRISD = 0;
	CLRF        TRISD+0 
;FlowBoard Mini.c,159 :: 		TRISB = 0;
	CLRF        TRISB+0 
;FlowBoard Mini.c,160 :: 		TRISA = 0;
	CLRF        TRISA+0 
;FlowBoard Mini.c,161 :: 		RCSTA1=1;
	MOVLW       1
	MOVWF       RCSTA1+0 
;FlowBoard Mini.c,163 :: 		ADCON0 = 0;
	CLRF        ADCON0+0 
;FlowBoard Mini.c,167 :: 		T1_Direction = 1;         // Set direction for buttons
	BSF         TRISD3_bit+0, BitPos(TRISD3_bit+0) 
;FlowBoard Mini.c,168 :: 		T2_Direction = 1;
	BSF         TRISD2_bit+0, BitPos(TRISD2_bit+0) 
;FlowBoard Mini.c,170 :: 		LD1_Direction = 0;        // Set direction for LEDS
	BCF         TRISA0_bit+0, BitPos(TRISA0_bit+0) 
;FlowBoard Mini.c,171 :: 		LD2_Direction = 0;
	BCF         TRISA1_bit+0, BitPos(TRISA1_bit+0) 
;FlowBoard Mini.c,172 :: 		LD1 = 0;                  // turn off leds
	BCF         LATA0_bit+0, BitPos(LATA0_bit+0) 
;FlowBoard Mini.c,173 :: 		LD2 = 0;
	BCF         LATA1_bit+0, BitPos(LATA1_bit+0) 
;FlowBoard Mini.c,175 :: 		D0_Direction = 0; //Output
	BCF         TRISD4_bit+0, BitPos(TRISD4_bit+0) 
;FlowBoard Mini.c,176 :: 		D0 = 0;
	BCF         LATD4_bit+0, BitPos(LATD4_bit+0) 
;FlowBoard Mini.c,177 :: 		D1_Direction = 0; //Output
	BCF         TRISD5_bit+0, BitPos(TRISD5_bit+0) 
;FlowBoard Mini.c,178 :: 		D1 = 0;
	BCF         LATD5_bit+0, BitPos(LATD5_bit+0) 
;FlowBoard Mini.c,180 :: 		An5_Direction = 1; //Input
	BSF         TRISE0_bit+0, BitPos(TRISE0_bit+0) 
;FlowBoard Mini.c,181 :: 		An6_Direction = 1; //Input
	BSF         TRISE1_bit+0, BitPos(TRISE1_bit+0) 
;FlowBoard Mini.c,182 :: 		An7_Direction = 1; //Input
	BSF         TRISE2_bit+0, BitPos(TRISE2_bit+0) 
;FlowBoard Mini.c,183 :: 		An10_Direction = 1; //Input
	BSF         TRISB1_bit+0, BitPos(TRISB1_bit+0) 
;FlowBoard Mini.c,184 :: 		An12_Direction = 1; //Input
	BSF         TRISB0_bit+0, BitPos(TRISB0_bit+0) 
;FlowBoard Mini.c,186 :: 		PWM9_Init(5000);      //5000 = 50Khz
	MOVLW       136
	MOVWF       FARG_PWM9_Init_PWM_Freq+0 
	MOVLW       19
	MOVWF       FARG_PWM9_Init_PWM_Freq+1 
	MOVLW       0
	MOVWF       FARG_PWM9_Init_PWM_Freq+2 
	MOVWF       FARG_PWM9_Init_PWM_Freq+3 
	CALL        _PWM9_Init+0, 0
;FlowBoard Mini.c,187 :: 		PWM9_Start();
	CALL        _PWM9_Start+0, 0
;FlowBoard Mini.c,188 :: 		PWM10_Init(5000);     //5000 = 50Khz
	MOVLW       136
	MOVWF       FARG_PWM10_Init_PWM_Freq+0 
	MOVLW       19
	MOVWF       FARG_PWM10_Init_PWM_Freq+1 
	MOVLW       0
	MOVWF       FARG_PWM10_Init_PWM_Freq+2 
	MOVWF       FARG_PWM10_Init_PWM_Freq+3 
	CALL        _PWM10_Init+0, 0
;FlowBoard Mini.c,189 :: 		PWM10_Start();
	CALL        _PWM10_Start+0, 0
;FlowBoard Mini.c,191 :: 		InitTimer0();             // initialize timer0
	CALL        _InitTimer0+0, 0
;FlowBoard Mini.c,193 :: 		DO0 = 0 ; DO0_Direction = 0;   //Output
	BCF         LATD1_bit+0, BitPos(LATD1_bit+0) 
	BCF         TRISD1_bit+0, BitPos(TRISD1_bit+0) 
;FlowBoard Mini.c,194 :: 		DO1 = 0 ; DO1_Direction = 0;   //Output
	BCF         LATD0_bit+0, BitPos(LATD0_bit+0) 
	BCF         TRISD0_bit+0, BitPos(TRISD0_bit+0) 
;FlowBoard Mini.c,195 :: 		DO2 = 0 ; DO2_Direction = 0;   //Output
	BCF         LATD6_bit+0, BitPos(LATD6_bit+0) 
	BCF         TRISD6_bit+0, BitPos(TRISD6_bit+0) 
;FlowBoard Mini.c,196 :: 		DO3 = 0 ; DO3_Direction = 0;   //Output
	BCF         LATC0_bit+0, BitPos(LATC0_bit+0) 
	BCF         TRISC0_bit+0, BitPos(TRISC0_bit+0) 
;FlowBoard Mini.c,197 :: 		DO4 = 0 ; DO4_Direction = 0;   //Output
	BCF         LATC1_bit+0, BitPos(LATC1_bit+0) 
	BCF         TRISC1_bit+0, BitPos(TRISC1_bit+0) 
;FlowBoard Mini.c,199 :: 		DI0_Direction = 1;   //Input
	BSF         TRISB5_bit+0, BitPos(TRISB5_bit+0) 
;FlowBoard Mini.c,200 :: 		DI1_Direction = 1;   //Input
	BSF         TRISB4_bit+0, BitPos(TRISB4_bit+0) 
;FlowBoard Mini.c,201 :: 		DI2_Direction = 1;   //Input
	BSF         TRISB3_bit+0, BitPos(TRISB3_bit+0) 
;FlowBoard Mini.c,202 :: 		DI3_Direction = 1;   //Input
	BSF         TRISB2_bit+0, BitPos(TRISB2_bit+0) 
;FlowBoard Mini.c,203 :: 		DI4_Direction = 1;   //Input
	BSF         TRISA2_bit+0, BitPos(TRISA2_bit+0) 
;FlowBoard Mini.c,205 :: 		clear_USB_buffers();
	CALL        _clear_USB_buffers+0, 0
;FlowBoard Mini.c,206 :: 		HID_Enable(&readbuff,&writebuff);       // Enable HID communication
	MOVLW       _readbuff+0
	MOVWF       FARG_HID_Enable_readbuff+0 
	MOVLW       hi_addr(_readbuff+0)
	MOVWF       FARG_HID_Enable_readbuff+1 
	MOVLW       _writebuff+0
	MOVWF       FARG_HID_Enable_writebuff+0 
	MOVLW       hi_addr(_writebuff+0)
	MOVWF       FARG_HID_Enable_writebuff+1 
	CALL        _HID_Enable+0, 0
;FlowBoard Mini.c,209 :: 		while (1){
L_main13:
;FlowBoard Mini.c,210 :: 		cnt++;   //Counter
	MOVLW       1
	ADDWF       main_cnt_L0+0, 1 
	MOVLW       0
	ADDWFC      main_cnt_L0+1, 1 
	ADDWFC      main_cnt_L0+2, 1 
	ADDWFC      main_cnt_L0+3, 1 
;FlowBoard Mini.c,212 :: 		if (cnt >200) {
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       main_cnt_L0+3, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main45
	MOVF        main_cnt_L0+2, 0 
	SUBLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main45
	MOVF        main_cnt_L0+1, 0 
	SUBLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main45
	MOVF        main_cnt_L0+0, 0 
	SUBLW       200
L__main45:
	BTFSC       STATUS+0, 0 
	GOTO        L_main15
;FlowBoard Mini.c,214 :: 		adc5 = ADC_Read(5);  // Read analog value
	MOVLW       5
	MOVWF       FARG_ADC_Read_channel+0 
	CALL        _ADC_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _adc5+0 
	MOVF        R1, 0 
	MOVWF       _adc5+1 
;FlowBoard Mini.c,215 :: 		writebuff[2]  = adc5 >>8; //LSB
	MOVF        R1, 0 
	MOVWF       R2 
	MOVLW       0
	BTFSC       R1, 7 
	MOVLW       255
	MOVWF       R3 
	MOVF        R2, 0 
	MOVWF       1346 
;FlowBoard Mini.c,216 :: 		writebuff[3]  = adc5; //MSB
	MOVF        R0, 0 
	MOVWF       1347 
;FlowBoard Mini.c,217 :: 		adc6 = ADC_Read(6);  // Read analog value
	MOVLW       6
	MOVWF       FARG_ADC_Read_channel+0 
	CALL        _ADC_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _adc6+0 
	MOVF        R1, 0 
	MOVWF       _adc6+1 
;FlowBoard Mini.c,218 :: 		writebuff[4]  = adc6>>8; //LSB
	MOVF        R1, 0 
	MOVWF       R2 
	MOVLW       0
	BTFSC       R1, 7 
	MOVLW       255
	MOVWF       R3 
	MOVF        R2, 0 
	MOVWF       1348 
;FlowBoard Mini.c,219 :: 		writebuff[5]  = adc6; //MSB
	MOVF        R0, 0 
	MOVWF       1349 
;FlowBoard Mini.c,220 :: 		adc7 = ADC_Read(7);  // Read analog value
	MOVLW       7
	MOVWF       FARG_ADC_Read_channel+0 
	CALL        _ADC_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _adc7+0 
	MOVF        R1, 0 
	MOVWF       _adc7+1 
;FlowBoard Mini.c,221 :: 		writebuff[6]  = adc7 >>8; //LSB
	MOVF        R1, 0 
	MOVWF       R2 
	MOVLW       0
	BTFSC       R1, 7 
	MOVLW       255
	MOVWF       R3 
	MOVF        R2, 0 
	MOVWF       1350 
;FlowBoard Mini.c,222 :: 		writebuff[7]  = adc7; //MSB
	MOVF        R0, 0 
	MOVWF       1351 
;FlowBoard Mini.c,223 :: 		adc10 = ADC_Read(10);  // Read analog value
	MOVLW       10
	MOVWF       FARG_ADC_Read_channel+0 
	CALL        _ADC_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _adc10+0 
	MOVF        R1, 0 
	MOVWF       _adc10+1 
;FlowBoard Mini.c,224 :: 		writebuff[8]  = adc10 >>8; //LSB
	MOVF        R1, 0 
	MOVWF       R2 
	MOVLW       0
	BTFSC       R1, 7 
	MOVLW       255
	MOVWF       R3 
	MOVF        R2, 0 
	MOVWF       1352 
;FlowBoard Mini.c,225 :: 		writebuff[9]  = adc10; //MSB
	MOVF        R0, 0 
	MOVWF       1353 
;FlowBoard Mini.c,226 :: 		adc12 = ADC_Read(12);  // Read analog value
	MOVLW       12
	MOVWF       FARG_ADC_Read_channel+0 
	CALL        _ADC_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _adc12+0 
	MOVF        R1, 0 
	MOVWF       _adc12+1 
;FlowBoard Mini.c,227 :: 		writebuff[10]  = adc12 >> 8; //LSB
	MOVF        R1, 0 
	MOVWF       R2 
	MOVLW       0
	BTFSC       R1, 7 
	MOVLW       255
	MOVWF       R3 
	MOVF        R2, 0 
	MOVWF       1354 
;FlowBoard Mini.c,228 :: 		writebuff[11]  = adc12; //MSB
	MOVF        R0, 0 
	MOVWF       1355 
;FlowBoard Mini.c,230 :: 		s0H = (servo0 >>8) &0xFF;
	MOVF        _servo0+1, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVLW       255
	ANDWF       R0, 0 
	MOVWF       _s0H+0 
;FlowBoard Mini.c,231 :: 		s0L = servo0 & 0xFF;
	MOVLW       255
	ANDWF       _servo0+0, 0 
	MOVWF       _s0L+0 
;FlowBoard Mini.c,232 :: 		s1H = (servo1 >>8) & 0xFF;
	MOVF        _servo1+1, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVLW       255
	ANDWF       R0, 0 
	MOVWF       _s1H+0 
;FlowBoard Mini.c,233 :: 		s1L = servo1 & 0xFF;
	MOVLW       255
	ANDWF       _servo1+0, 0 
	MOVWF       _s1L+0 
;FlowBoard Mini.c,235 :: 		if (oldSet == 0) {
	MOVF        _oldSet+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_main16
;FlowBoard Mini.c,236 :: 		set1 = 1;
	MOVLW       1
	MOVWF       _set1+0 
;FlowBoard Mini.c,237 :: 		oldSet = 1;
	MOVLW       1
	MOVWF       _oldSet+0 
;FlowBoard Mini.c,238 :: 		} else {
	GOTO        L_main17
L_main16:
;FlowBoard Mini.c,239 :: 		set2 = 1;
	MOVLW       1
	MOVWF       _set2+0 
;FlowBoard Mini.c,240 :: 		oldSet = 0;
	CLRF        _oldSet+0 
;FlowBoard Mini.c,241 :: 		}
L_main17:
;FlowBoard Mini.c,242 :: 		cnt = 0;
	CLRF        main_cnt_L0+0 
	CLRF        main_cnt_L0+1 
	CLRF        main_cnt_L0+2 
	CLRF        main_cnt_L0+3 
;FlowBoard Mini.c,243 :: 		}
L_main15:
;FlowBoard Mini.c,247 :: 		if ((readbuff[0] & 0x01 )> 0) {
	MOVLW       1
	ANDWF       1280, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_main18
;FlowBoard Mini.c,248 :: 		LD1 = 1;
	BSF         LATA0_bit+0, BitPos(LATA0_bit+0) 
;FlowBoard Mini.c,249 :: 		}  else LD1 = 0;
	GOTO        L_main19
L_main18:
	BCF         LATA0_bit+0, BitPos(LATA0_bit+0) 
L_main19:
;FlowBoard Mini.c,250 :: 		if ((readbuff[0] & 0x02 )> 0) {
	MOVLW       2
	ANDWF       1280, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_main20
;FlowBoard Mini.c,251 :: 		LD2 = 1;
	BSF         LATA1_bit+0, BitPos(LATA1_bit+0) 
;FlowBoard Mini.c,252 :: 		}  else LD2 = 0;
	GOTO        L_main21
L_main20:
	BCF         LATA1_bit+0, BitPos(LATA1_bit+0) 
L_main21:
;FlowBoard Mini.c,254 :: 		if ((readbuff[0] & 0x04 )> 0) {
	MOVLW       4
	ANDWF       1280, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_main22
;FlowBoard Mini.c,255 :: 		DO0 = 1;
	BSF         LATD1_bit+0, BitPos(LATD1_bit+0) 
;FlowBoard Mini.c,256 :: 		}  else DO0 = 0;
	GOTO        L_main23
L_main22:
	BCF         LATD1_bit+0, BitPos(LATD1_bit+0) 
L_main23:
;FlowBoard Mini.c,257 :: 		if ((readbuff[0] & 0x08 )> 0) {
	MOVLW       8
	ANDWF       1280, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_main24
;FlowBoard Mini.c,258 :: 		DO1 = 1;
	BSF         LATD0_bit+0, BitPos(LATD0_bit+0) 
;FlowBoard Mini.c,259 :: 		}  else DO1 = 0;
	GOTO        L_main25
L_main24:
	BCF         LATD0_bit+0, BitPos(LATD0_bit+0) 
L_main25:
;FlowBoard Mini.c,260 :: 		if ((readbuff[0] & 0x10 )> 0) {
	MOVLW       16
	ANDWF       1280, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_main26
;FlowBoard Mini.c,261 :: 		DO2 = 1;
	BSF         LATD6_bit+0, BitPos(LATD6_bit+0) 
;FlowBoard Mini.c,262 :: 		}  else DO2 = 0;
	GOTO        L_main27
L_main26:
	BCF         LATD6_bit+0, BitPos(LATD6_bit+0) 
L_main27:
;FlowBoard Mini.c,263 :: 		if ((readbuff[0] & 0x20 )> 0) {
	MOVLW       32
	ANDWF       1280, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_main28
;FlowBoard Mini.c,264 :: 		DO3 = 1;
	BSF         LATC0_bit+0, BitPos(LATC0_bit+0) 
;FlowBoard Mini.c,265 :: 		}  else DO3 = 0;
	GOTO        L_main29
L_main28:
	BCF         LATC0_bit+0, BitPos(LATC0_bit+0) 
L_main29:
;FlowBoard Mini.c,266 :: 		if ((readbuff[0] & 0x40 )> 0) {
	MOVLW       64
	ANDWF       1280, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_main30
;FlowBoard Mini.c,267 :: 		DO4 = 1;
	BSF         LATC1_bit+0, BitPos(LATC1_bit+0) 
;FlowBoard Mini.c,268 :: 		}  else DO4 = 0;
	GOTO        L_main31
L_main30:
	BCF         LATC1_bit+0, BitPos(LATC1_bit+0) 
L_main31:
;FlowBoard Mini.c,273 :: 		writebuff[0]=0;
	CLRF        1344 
;FlowBoard Mini.c,274 :: 		writebuff[0] = writebuff[0] | read_button1() ;
	CALL        _read_button1+0, 0
	MOVF        R0, 0 
	IORWF       1344, 1 
;FlowBoard Mini.c,275 :: 		writebuff[0] = writebuff[0] | read_button2() ;
	CALL        _read_button2+0, 0
	MOVF        R0, 0 
	IORWF       1344, 1 
;FlowBoard Mini.c,277 :: 		if (DI0 == 1) writebuff[0] = writebuff[0] | 0x04;
	BTFSS       RB5_bit+0, BitPos(RB5_bit+0) 
	GOTO        L_main32
	BSF         1344, 2 
L_main32:
;FlowBoard Mini.c,278 :: 		if (DI1 == 1) writebuff[0] = writebuff[0] | 0x08;
	BTFSS       RB4_bit+0, BitPos(RB4_bit+0) 
	GOTO        L_main33
	BSF         1344, 3 
L_main33:
;FlowBoard Mini.c,279 :: 		if (DI2 == 1) writebuff[0] = writebuff[0] | 0x10;
	BTFSS       RB3_bit+0, BitPos(RB3_bit+0) 
	GOTO        L_main34
	BSF         1344, 4 
L_main34:
;FlowBoard Mini.c,280 :: 		if (DI3 == 1) writebuff[0] = writebuff[0] | 0x20;
	BTFSS       RB2_bit+0, BitPos(RB2_bit+0) 
	GOTO        L_main35
	BSF         1344, 5 
L_main35:
;FlowBoard Mini.c,281 :: 		if (DI4 == 1) writebuff[0] = writebuff[0] | 0x40;
	BTFSS       RA2_bit+0, BitPos(RA2_bit+0) 
	GOTO        L_main36
	BSF         1344, 6 
L_main36:
;FlowBoard Mini.c,283 :: 		PWM9_Set_Duty(readbuff[1]);
	MOVF        1281, 0 
	MOVWF       FARG_PWM9_Set_Duty_new_duty+0 
	CALL        _PWM9_Set_Duty+0, 0
;FlowBoard Mini.c,284 :: 		PWM10_Set_Duty(readbuff[2]);
	MOVF        1282, 0 
	MOVWF       FARG_PWM10_Set_Duty_new_duty+0 
	CALL        _PWM10_Set_Duty+0, 0
;FlowBoard Mini.c,287 :: 		kk = HID_Read();
	CALL        _HID_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _kk+0 
;FlowBoard Mini.c,288 :: 		if (kk != 0)
	MOVF        R0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_main37
;FlowBoard Mini.c,290 :: 		S0 = readbuff[3] << 8;
	MOVF        1283, 0 
	MOVWF       R1 
	CLRF        R0 
	MOVF        R0, 0 
	MOVWF       _S0+0 
	MOVF        R1, 0 
	MOVWF       _S0+1 
;FlowBoard Mini.c,291 :: 		S0 = S0 + readbuff[4];
	MOVF        1284, 0 
	ADDWF       R0, 1 
	MOVLW       0
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	MOVWF       _S0+0 
	MOVF        R1, 0 
	MOVWF       _S0+1 
;FlowBoard Mini.c,293 :: 		servo0 = (S0 *21) + 37125; //scale for servos
	MOVLW       21
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       5
	ADDWF       R0, 0 
	MOVWF       _servo0+0 
	MOVLW       145
	ADDWFC      R1, 0 
	MOVWF       _servo0+1 
;FlowBoard Mini.c,294 :: 		S1 = readbuff[5] << 8;
	MOVF        1285, 0 
	MOVWF       R1 
	CLRF        R0 
	MOVF        R0, 0 
	MOVWF       _S1+0 
	MOVF        R1, 0 
	MOVWF       _S1+1 
;FlowBoard Mini.c,295 :: 		S1 = S1 + readbuff[6];
	MOVF        1286, 0 
	ADDWF       R0, 1 
	MOVLW       0
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	MOVWF       _S1+0 
	MOVF        R1, 0 
	MOVWF       _S1+1 
;FlowBoard Mini.c,297 :: 		servo1 = (S1 *21) + 37125; //scale for servos
	MOVLW       21
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       5
	ADDWF       R0, 0 
	MOVWF       _servo1+0 
	MOVLW       145
	ADDWFC      R1, 0 
	MOVWF       _servo1+1 
;FlowBoard Mini.c,298 :: 		HID_Write(&writebuff,64);
	MOVLW       _writebuff+0
	MOVWF       FARG_HID_Write_writebuff+0 
	MOVLW       hi_addr(_writebuff+0)
	MOVWF       FARG_HID_Write_writebuff+1 
	MOVLW       64
	MOVWF       FARG_HID_Write_len+0 
	CALL        _HID_Write+0, 0
;FlowBoard Mini.c,299 :: 		}
L_main37:
;FlowBoard Mini.c,300 :: 		}
	GOTO        L_main13
;FlowBoard Mini.c,301 :: 		}
L_end_main:
	GOTO        $+0
; end of _main
