/*
 DSPRobotics
 FlowBoard Mini   V1.00    (PIC Clicker)
 Language: Mikro C Pro
 Chip: P18F47J53
 CLK: 48Mhz
 
 Notes: DI2,3,4 & DO5 not implemented yet
 */
/*---------------------------------------------------------------*/
// USB buffers
unsigned char readbuff[64] absolute 0x500;   // Buffers should be in USB RAM, please consult datasheet
unsigned char writebuff[64] absolute 0x540;

//General
char cnt;
char kk;
char i,j;
unsigned S0 = 512;    //Servo  time
unsigned S1 = 512;
unsigned servo0 = 47704;
unsigned servo1 = 47704;
int x;
int adc5 = 0;
int adc6 = 0;
int adc7 = 0;
int adc10 = 0;
int adc12 = 0;
char set1 = 0;
char set2 = 0;
char oldSet = 0;
char s0H,s0L,s1H,s1L;

// pin definitions
//LEDs
sbit LD1 at LATA0_bit;    //LED 1
sbit LD2 at LATA1_bit;    //LED 2
sbit LD1_Direction at TRISA0_bit;
sbit LD2_Direction at TRISA1_bit;
//Button Inputs
sbit T1 at RD3_bit;   //Button 1
sbit T2 at RD2_bit;   //Button 2
sbit T1_Direction at TRISD3_bit;
sbit T2_Direction at TRISD2_bit;
//Servo Pins
sbit D0 at LATD4_bit;   //Data 0
sbit D0_Direction at  TRISD4_bit;  //Output
sbit D1 at LATD5_bit;   //Data1
sbit D1_Direction at  TRISD5_bit;  //Output
//ADC
sbit An5_Direction at TRISE0_bit;    //Tx Direction
sbit An6_Direction at TRISE1_bit;    //Tx Direction
sbit An7_Direction at TRISE2_bit;    //Tx Direction
sbit An10_Direction at TRISB1_bit;    //Tx Direction
sbit An12_Direction at TRISB0_bit;    //Tx Direction
//Dout
sbit DO0 at LATD1_bit; // pin
sbit DO0_Direction at TRISD1_bit;    //Direction
sbit DO1 at LATD0_bit; // pin
sbit DO1_Direction at TRISD0_bit;    //Direction
sbit DO2 at LATD6_bit; // pin
sbit DO2_Direction at TRISD6_bit;    //Direction
sbit DO3 at LATC0_bit; // pin
sbit DO3_Direction at TRISC0_bit;    //Direction
sbit DO4 at LATC1_bit; // pin
sbit DO4_Direction at TRISC1_bit;    //Direction
//Din
sbit DI0 at RB5_bit; // pin
sbit DI0_Direction at TRISB5_bit;    //Direction
sbit DI1 at RB4_bit; // pin
sbit DI1_Direction at TRISB4_bit;    //Direction
sbit DI2 at RB3_bit; // pin
sbit DI2_Direction at TRISB3_bit;    //Direction
sbit DI3 at RB2_bit; // pin
sbit DI3_Direction at TRISB2_bit;    //Direction
sbit DI4 at RA2_bit; // pin
sbit DI4_Direction at TRISA2_bit;    //Direction

/*---------------------------------------------------------------*/
// Interrupt routine
void interrupt() {
if (TMR0IF_bit){    //Servos
    // clear timer0 Interrupt flag
    TMR0IF_bit = 0;
    //D0 = ~D0;
    if (set1 ==1){
    D0 = 1;
    set1 = 0;

    TMR0H = s0H;         // Set Timer0 Interrupt time     should come from readbuff 3 & 4
    TMR0L = s0L;         // Servo Min = 58284 Max = 37125

    }else {
    D0 = 0;
    }
    if (set2 ==1){
    D1 = 1;
    set2 = 0;

    TMR0H = s1H;         // Set Timer0 Interrupt time     should come from readbuff 3 & 4
    TMR0L = S1L;         // Servo Min = 58284 Max = 37125

    }else {
    D1 = 0;
    }
       
  } else {

   USB_Interrupt_Proc();                   // USB servicing is done inside the interrupt

   }
}
/*---------------------------------------------------------------*/
//Timer0
//Prescaler 1:4; TMR0 Preload = 18660; Actual Interrupt Time : 1.5ms
void InitTimer0(){
  T0CON         = 0x88;
  TMR0H         = 0xBA;     //BA58 = 47704 = 1.5ms
  TMR0L         = 0x58;
  GIE_bit       = 1;        //Enable Interrupts
  TMR0IF_bit    = 0;
  TMR0IE_bit    = 1;
  
  //set initial values
  s0H = 0xBA;
  s0L = 0x58;
  s1H = 0xBA;
  s1L = 0x58;

}
/*---------------------------------------------------------------*/
void clear_USB_buffers()
{
   for (i=0; i<63;i++)
   {
   readbuff[i] = 0;
   writebuff[i] = 0;
   }
}
/*---------------------------------------------------------------*/
char read_button1() {
  if (Button(&PORTD, 3, 2, 0)) {               // Detect logical one
      return  1;                              // Update flag
    } else return 0;
}
/*---------------------------------------------------------------*/
char read_button2() {
  if (Button(&PORTD, 2, 2, 0)) {               // Detect logical one
      return  2;                              // Update flag
    } else return 0;
}
/*---------------------------------------------------------------*/
void main(){
  long cnt = 0;

  ANCON0 = 0;               // Default all pins to digital
  ANCON1 = 0;
  TRISD = 0;
  TRISB = 0;
  TRISA = 0;
  RCSTA1=1;
  //CM1CON = 0xCF;               // Disable comparators  affects PA0-3
   ADCON0 = 0;


  //Buttons
  T1_Direction = 1;         // Set direction for buttons
  T2_Direction = 1;
  //Leds
  LD1_Direction = 0;        // Set direction for LEDS
  LD2_Direction = 0;
  LD1 = 0;                  // turn off leds
  LD2 = 0;
  //Servos
  D0_Direction = 0; //Output
  D0 = 0;
  D1_Direction = 0; //Output
  D1 = 0;
  //A/D Pins
  An5_Direction = 1; //Input
  An6_Direction = 1; //Input
  An7_Direction = 1; //Input
  An10_Direction = 1; //Input
  An12_Direction = 1; //Input
  //PWM
  PWM9_Init(5000);      //5000 = 50Khz
  PWM9_Start();
  PWM10_Init(5000);     //5000 = 50Khz
  PWM10_Start();
 //Timer 0
  InitTimer0();             // initialize timer0
  //Dout
  DO0 = 0 ; DO0_Direction = 0;   //Output
  DO1 = 0 ; DO1_Direction = 0;   //Output
  DO2 = 0 ; DO2_Direction = 0;   //Output
  DO3 = 0 ; DO3_Direction = 0;   //Output
  DO4 = 0 ; DO4_Direction = 0;   //Output
  //Din
  DI0_Direction = 1;   //Input
  DI1_Direction = 1;   //Input
  DI2_Direction = 1;   //Input
  DI3_Direction = 1;   //Input
  DI4_Direction = 1;   //Input
 //HID
  clear_USB_buffers();
  HID_Enable(&readbuff,&writebuff);       // Enable HID communication
 /*---------------------------------------------------------------*/
 //Main Loop
  while (1){
   cnt++;   //Counter
  //Send Servo Pulses
  if (cnt >200) {
  //Read ADC
    adc5 = ADC_Read(5);  // Read analog value
    writebuff[2]  = adc5 >>8; //LSB
    writebuff[3]  = adc5; //MSB
    adc6 = ADC_Read(6);  // Read analog value
    writebuff[4]  = adc6>>8; //LSB
    writebuff[5]  = adc6; //MSB
    adc7 = ADC_Read(7);  // Read analog value
    writebuff[6]  = adc7 >>8; //LSB
    writebuff[7]  = adc7; //MSB
    adc10 = ADC_Read(10);  // Read analog value
    writebuff[8]  = adc10 >>8; //LSB
    writebuff[9]  = adc10; //MSB
    adc12 = ADC_Read(12);  // Read analog value
    writebuff[10]  = adc12 >> 8; //LSB
    writebuff[11]  = adc12; //MSB
   
    s0H = (servo0 >>8) &0xFF;
    s0L = servo0 & 0xFF;
    s1H = (servo1 >>8) & 0xFF;
    s1L = servo1 & 0xFF;
    
    if (oldSet == 0) {
     set1 = 1;
     oldSet = 1;
    } else {
     set2 = 1;
     oldSet = 0;
    }
    cnt = 0;
  }
   
  //Read Input buffer - Outputs
  //LEDS
   if ((readbuff[0] & 0x01 )> 0) {
     LD1 = 1;
   }  else LD1 = 0;
   if ((readbuff[0] & 0x02 )> 0) {
     LD2 = 1;
   }  else LD2 = 0;
   //Douts
   if ((readbuff[0] & 0x04 )> 0) {
     DO0 = 1;
   }  else DO0 = 0;
   if ((readbuff[0] & 0x08 )> 0) {
     DO1 = 1;
   }  else DO1 = 0;
      if ((readbuff[0] & 0x10 )> 0) {
     DO2 = 1;
   }  else DO2 = 0;
   if ((readbuff[0] & 0x20 )> 0) {
     DO3 = 1;
   }  else DO3 = 0;
      if ((readbuff[0] & 0x40 )> 0) {
     DO4 = 1;
   }  else DO4 = 0;


  //Write Outputs to buffer
  //Buttons
  writebuff[0]=0;
  writebuff[0] = writebuff[0] | read_button1() ;
  writebuff[0] = writebuff[0] | read_button2() ;
  //Dins
  if (DI0 == 1) writebuff[0] = writebuff[0] | 0x04;
  if (DI1 == 1) writebuff[0] = writebuff[0] | 0x08;
  if (DI2 == 1) writebuff[0] = writebuff[0] | 0x10;
  if (DI3 == 1) writebuff[0] = writebuff[0] | 0x20;
  if (DI4 == 1) writebuff[0] = writebuff[0] | 0x40;
  //Servo PWM
  PWM9_Set_Duty(readbuff[1]);
  PWM10_Set_Duty(readbuff[2]);
  //USB

  kk = HID_Read();
  if (kk != 0)
  {
   S0 = readbuff[3] << 8;
   S0 = S0 + readbuff[4];
   //if (S0 >1024) S0 = 1024;
   servo0 = (S0 *21) + 37125; //scale for servos
   S1 = readbuff[5] << 8;
   S1 = S1 + readbuff[6];
   //if (S1 >1024) S1 = 1024;
   servo1 = (S1 *21) + 37125; //scale for servos
   HID_Write(&writebuff,64);
  }
 }
}