/*
 DSPRobotics
 FlowBoard Mini   V1.00
 */
/*---------------------------------------------------------------*/
// USB
unsigned char readbuff[64] absolute 0x500;   // Buffers should be in USB RAM, please consult datasheet
unsigned char writebuff[64] absolute 0x540;

char cnt;
char kk;
char i,j;
unsigned S0 = 512;    //Servo  time
unsigned S1 = 512;
unsigned servo0 = 47704;
unsigned servo1 = 47704;
int x;
int adc5 = 0;
int adc6 = 0;
int adc7 = 0;
int adc10 = 0;
int adc12 = 0;

char set1 = 0;
char set2 = 0;
char oldSet = 0;
char s0H,s0L,s1H,s1L;

// pin definitions
sbit LD1 at LATA0_bit;    //LED 1
sbit LD2 at LATA1_bit;    //LED 2
sbit LD1_Direction at TRISA0_bit;
sbit LD2_Direction at TRISA1_bit;

//Button Inputs
sbit T1 at RD3_bit;   //Button 1
sbit T2 at RD2_bit;   //Button 2
sbit T1_Direction at TRISD3_bit;
sbit T2_Direction at TRISD2_bit;

sbit D0 at LATD4_bit;   //Data 0
sbit D0_Direction at  TRISD4_bit;  //Output
sbit D1 at LATD5_bit;   //Data1
sbit D1_Direction at  TRISD5_bit;  //Output

sbit Tx at RD6_bit; //TX pin
sbit Tx_Direction at TRISD6_bit;    //Tx Direction




/*---------------------------------------------------------------*/
// Interrupt routine
void interrupt() {
//Timer 0
if (TMR0IF_bit){
    // clear timer0 Interrupt flag
    TMR0IF_bit = 0;
    //D0 = ~D0;
    if (set1 ==1){   //servo pulse 0
    D0 = 1;
    set1 = 0;

    TMR0H = s0H;         // Set Timer0 Interrupt time     should come from readbuff 3 & 4
    TMR0L = s0L;         // Servo Min = 58284 Max = 37125

    }else {
    D0 = 0;
    }
    if (set2 ==1){//Servo Pulse 1
    D1 = 1;
    set2 = 0;

    TMR0H = s1H;         // Set Timer0 Interrupt time     should come from readbuff 3 & 4
    TMR0L = S1L;         // Servo Min = 58284 Max = 37125

    }else {
    D1 = 0;
    }
       
  }
   
}
/*---------------------------------------------------------------*/
//Timer0
//Prescaler 1:4; TMR0 Preload = 18660; Actual Interrupt Time : 1.5ms
void InitTimer0(){
  T0CON         = 0x88;
  TMR0H         = 0xBA;     //BA58 = 47704 = 1.5ms
  TMR0L         = 0x58;
  GIE_bit       = 1;        //Enable Interrupts
  TMR0IF_bit    = 0;
  TMR0IE_bit    = 1;
  
  //set initial values
  s0H = 0xBA;
  s0L = 0x58;
  s1H = 0xBA;
  s1L = 0x58;

}
/*---------------------------------------------------------------*/
//Timer3
//Prescaler 1:2; TMR3 Preload = 5536; Actual Interrupt Time : 10 ms
void InitTimer3(){
  T3CON	 = 0x21;
  TMR3IF_bit	 = 0;
  TMR3H	 = 0x15;
  TMR3L	 = 0xA0;
  TMR3IE_bit	 = 1;
  INTCON	 = 0xC0;
}
/*---------------------------------------------------------------*/
void clear_USB_buffers()
{
   for (i=0; i<63;i++)
   {
   readbuff[i] = 0;
   writebuff[i] = 0;
   }
}
/*---------------------------------------------------------------*/
char read_button1() {
  if (Button(&PORTD, 3, 2, 0)) {               // Detect logical one
      return  1;                              // Update flag
    } else return 0;
}
/*---------------------------------------------------------------*/
char read_button2() {
  if (Button(&PORTD, 2, 2, 0)) {               // Detect logical one
      return  2;                              // Update flag
    } else return 0;
}
/*---------------------------------------------------------------*/
void main(){
  long cnt = 0;

//Init
  ANCON0 = 0;               // Default all pins to digital
  ANCON1 = 0;
  TRISD = 0;

  RCSTA1=1;
  TRISC6_bit = 0;
  TRISC7_bit = 1;

  T1_Direction = 1;         // Set direction for buttons
  T2_Direction = 1;

  LD1_Direction = 0;        // Set direction for LEDS
  LD2_Direction = 0;
  LD1 = 0;                  // turn off leds
  LD2 = 0;
  
  D0_Direction = 0; //Output
  D0 = 0;
  D1_Direction = 0; //Output
  D1 = 0;

//ADC
  //ADC_Init();  // Initialize ADC module with default settings

//PWM
  PWM9_Init(5000);
  PWM9_Start();
  PWM10_Init(5000);
  PWM10_Start();
//Timers
  InitTimer0();             // initialize timer0 - servo Pulse width
  InitTimer3();             // initialize timer3 - servo pulst interval

//HID
  clear_USB_buffers();
  HID_Enable(&readbuff,&writebuff);       // Enable HID communication
  
 /*---------------------------------------------------------------*/
  while (1){
// Inc Loop counter
  cnt++;
//Read ADC
  //adc5 = ADC_Get_Sample(5);  // Read analog value
  writebuff[2]  = adc5; //LSB
  writebuff[3]  = adc5 >>8; //MSB
  //adc6 = ADC_Get_Sample(6);  // Read analog value
  writebuff[4]  = adc6; //LSB
  writebuff[5]  = adc6 >>8; //MSB
 // adc7 = ADC_Read(7);  // Read analog value
  writebuff[6]  = adc7; //LSB
  writebuff[7]  = adc7 >>8; //MSB
 // adc10 = ADC_Read(10);  // Read analog value
  writebuff[8]  = adc10; //LSB
  writebuff[9]  = adc10 >>8; //MSB
 // adc12 = ADC_Read(12);  // Read analog value
  writebuff[10]  = adc12; //LSB
  writebuff[11]  = adc12 >>8; //MSB

    USB_Polling_Proc();
   
   
//Send Servo Pulses
   if (cnt >200) {   //200 = ~10ms/2 = 20ms/servo pulse
   

     kk = HID_Read();
     if (kk != 0)
     {
     S0 = readbuff[3] << 8;
     S0 = S0 + readbuff[4];
     //if (S0 >1024) S0 = 1024;
     servo0 = (S0 *21) + 37125; //scale for servos
     S1 = readbuff[5] << 8;
     S1 = S1 + readbuff[6];
     //if (S1 >1024) S1 = 1024;
     servo1 = (S1 *21) + 37125; //scale for servos

     //Set Servo Times
     s0H = (servo0 >>8) &0xFF;
     s0L = servo0 & 0xFF;
     s1H = (servo1 >>8) & 0xFF;
     s1L = servo1 & 0xFF;

     HID_Write(&writebuff,64);
     }
    
     if (oldSet == 0) {     //Send Servo Pulse 0
       set1 = 1;
       oldSet = 1;
     } else {              //Send Servo Pulse 1
       set2 = 1;
       oldSet = 0;
     }




    cnt = 0;
   }
   
//Read Input buffer for LEDS
   if ((readbuff[0] & 0x01 )> 0) {
     LD1 = 1;   //Led 1 On
   }  else LD1 = 0;
   
   if ((readbuff[0] & 0x02 )> 0) {
     LD2 = 1;   //Led 2 On
   }  else LD2 = 0;
   
//Write Outputs to buffer  0for Buttons
  writebuff[0]=0;
  writebuff[0] = writebuff[0] | read_button1() ;
  writebuff[0] = writebuff[0] | read_button2() ;
  
  //PWM for DC Motors or LED Brightness
  PWM9_Set_Duty(readbuff[1]);
  PWM10_Set_Duty(readbuff[2]);
  /*---------------------------------------------------------------*/
  //USB



   /*---------------------------------------------------------------*/
   //LATB = ~LATB;     // Toggle LEDs on PORTB

  }

}